#version 330

layout(location = 0) in vec3 position;

uniform mat4 vpMatrix;
uniform vec3 cameraPosition;
uniform mat4 modelMatrix;

void main()
{

	gl_Position =  vpMatrix * modelMatrix * vec4(position.xyz, 1);

	// we are scaling the point size using a simple constant + linear + quadratic attenuation model
	float dist = distance(gl_Position.xyz, cameraPosition);
	float constAtt  = 1.0f;
	float linAtt = 0.2;
	float squareAtt = 0.001;
	float totalAtt = constAtt + linAtt*dist + squareAtt * dist * dist;
	gl_PointSize = 800 / totalAtt;
}

