#version 330

layout(points) in;
layout(points) out;
layout(max_vertices = 30) out;

in vec3 gPosition[];
in vec3 gVelocity[];
in float gAge[];
in float gType[]; // 1 = emitter, 0 = normales partikel

out vec3 fPosition;
out vec3 fVelocity;
out float fAge;
out float fType;

uniform float elapsedTime;

#define TYPE_EMITTER 1.0f
#define TYPE_PARTICLE 0.0f

void main(){
	if(gType[0] == TYPE_EMITTER){
		// den emitter neu emittieren
		fPosition = gPosition[0];
		fVelocity = gVelocity[0];
		fAge = 0.0f;
		fPosition = gPosition[0];
		fType = TYPE_EMITTER;
		EmitVertex();
		EndPrimitive();

		vec3 currVelocity = gVelocity[0];

		// und noch einen zustzlichen partikel auf der 0-position emittieren
		fPosition = gPosition[0];
		fVelocity = gVelocity[0];
		fAge = 0.0f;
		fType = TYPE_PARTICLE;
		EmitVertex();
		EndPrimitive();

		fPosition = gPosition[0];
		fVelocity = vec3(-currVelocity.x, -currVelocity.y, currVelocity.z);
		fAge = 0.0f;
		fType = TYPE_PARTICLE;
		EmitVertex();
		EndPrimitive();
	}else{
		// normale partikel werden nur in der position upgedatet
		fAge = gAge[0] + elapsedTime;
		if(fAge < 6.0f){
			fPosition = gPosition[0] + (gVelocity[0] * elapsedTime);
			fVelocity = gVelocity[0] - vec3(0.01f, 0.01f, 0.01f);
			fType = TYPE_PARTICLE;
			EmitVertex();
			EndPrimitive();
		}
	}
}