#version 330

const int MAX_BONES = 100;

layout(location = 0) in vec4 position;
layout(location = 4) in ivec4 bones;
layout(location = 5) in vec4 weights;

uniform mat4 MVP;
uniform mat4 boneTransformations[MAX_BONES];

out vec4 vertexPosition;

void main()
{
	mat4 boneTransform  = boneTransformations[bones[0]] * weights[0];
	     boneTransform += boneTransformations[bones[1]] * weights[1];
		 boneTransform += boneTransformations[bones[2]] * weights[2];
		 boneTransform += boneTransformations[bones[3]] * weights[3];

	gl_Position = MVP * boneTransform * position;
}
