

# <center> Computer Defender <br />Documentation for Assignment 2 <br /><small>Markus Scherer, Lukas Köll</small> </center>

<br /><br />

## Implementation ##

### Gameplay

### Complex Objects

Well, I guess you can see them in our game ^^

### Animated Objects

We have Vertex skinning  :P

### View Frustum Culling

We do our frustum culling in clip space. See FrustumCuller.cpp for the exact implementation.

You can see the culling when you have the FPS/Drawn Objects counter on. Best try turning to a corner, there only the 3-4 objects should be rendered. The counter might not instantly decrease when an object is out of your vision. that is because we use bounding spheres for the culling-test which are a bit too generous, but therefore cheap to calculate ;-)

### Transparency

Transparency comes in when you fire projectiles (the explosion particles are transparent) and during tower-placement, where the tower-ghost is transparent.

### OpenGL Experiments

Implemented just as a struct which contains several booleans that are read out during the rendering process.

### Controls ###

| Control        | Action      | 
|:---------------|:------------|
| WASD           | Move the player forward/backward turn left/right |
| TAB            | starts Debug mode |
| CTRL-TAB       | Disables Debug mode |
| Spacebar       | jump |
| Drag mouse horizontally | Make Camera orbit around android |
| B              | Start/Stop Build mode |
| Right-Click    | Shoot in look direction |
| Right-Click in Build mode       | build tower *| 
| __Evaluation/Debugging__
|F1|Help (none available atm)|
|F2|Fame Time / Drawn Objects on off|
|F3|Wire Frame on/off|
|F4|Texture Sampling Quality|
|F5|Mip-Mapping Quality|
|F6|Win Level|
|F8|Viewfrustum-Culling on/off|
|F9|Transparency on/off|

* you cannot build towers, you cannot build indefinite amounts of towers, you have to build build towers near gus

## Features ##

* Multiple light sources
* Shadow Mapping
* Shooting
* Orbiting Camera (automatically returns to original position)
* Flexible Level Design
* easily extendable due to Event System
* Collision Detection
* Jumping
* Projectile Explosion


## Lighting ###

We currently use 4 independant point light sources which illuminate all objects. A Light object does basically inherit all properties from a SceneObject and adds things like vec3 color. You can decide wether or not an object will be textured or not by using the according Material. The Material name is read from the imported model file. (StandardMaterial for example will render a white Object with blinn/phong illumination but no texture while LightedTextureMaterial will use a Texture and also use the lighting information).

Illumination is done via Blinn model and shading via Phong right now. Currently, all parameters such as ambient, diffuse and specular reflection coefficient are static, but we plan to read them from the material properties in the future.

Shadows are generated with Shadowmaps, see Section Shadowmaps for further explanation.

## Additional Libraries ##

We used the following external libraries:

| Library    | Purpose   | URL       |
|:-----------|:----------|:----------|
|Assimp      |Model and Material Loading            |[http://assimp.sourceforge.net/](http://assimp.sourceforge.net/)|
|GLM         |OpenGL compatible vectors and matrices|[http://glm.g-truc.net/](http://glm.g-truc.net/)|
|FreeImage   |Image loading                         |[http://freeimage.sourceforge.net/](http://freeimage.sourceforge.net/)|
|GLFW        |Window Handling                       |[http://www.glfw.org/](http://www.glfw.org/)|
|GLEW        |easier handling of OpenGL             |[http://glew.sourceforge.net/](http://glew.sourceforge.net/)|
|FreeType    | Text Rendering                       | [http://www.freetype.org/](http://www.freetype.org/) |
|Coldet      | Collision Detection                  |[http://sourceforge.net/projects/coldet/](http://sourceforge.net/projects/coldet/)

## Effects

// How were they implemented

### Shadowmapping with PCF

We used this [Tutorial](http://http.developer.nvidia.com/GPUGems/gpugems_ch11.html) from GPU gems and the Slides from the Repetitorium.

### Vertex Skinning

We used these tutorials to implement Vertex Skinning:

* [OGL-Dev - Tutorial 38 - Skeletal Animation With Assimp](http://ogldev.atspace.co.uk/www/tutorial38/tutorial38.html)
* [Ephenation OpenGL - Doing animations in OpenGL](http://ephenationopengl.blogspot.co.at/2012/06/doing-animations-in-opengl.html)

But implemented our own data structures for efficiency.

And this code as referencw implementation to debug against:

* [assimp 3.0 opengl demo with bone animation](http://drivenbynostalgia.com/stuff.html)

And this 
### Particle Rendering

We read several websites, among which where the following:

* [GPU-Gems Particles Paper](http://http.developer.nvidia.com/GPUGems3/gpugems3_ch23.html)
* [OGL-Dev Particles Tutorial](http://ogldev.atspace.co.uk/www/tutorial28/tutorial28.html)

Finally, we used a transform feedback buffer to update the particles directly on the GPU and rendered them then, using a quadratic attenuation for the particles size when they are further away from the viewer to create the illusion of perspective.

We did not use billboarding, instead we drew with GL_POINTS and a big point size (which made the attenuation-hack neccesary) and applying a texture to those points.

## Special Features

* self made sounds
* self made meshes and levels
* self written outro song :P

## Tools (modeling, sound)

We used Garageband for the recording of our sounds, Blender for the modeling 

## Complex interaction sequences

I hope there are no interactions that require explanation. should there still be questions, don't hesitate to contact customer support (i.e. us ;-) )

## Screenshot in png 1024x768

## Video h264 encoded 640x480 as .zip



